<?PHP

/*************************************************************************
*	Application:	Wordpress Content Warning
*	Version:		2.0
*
*	Filename: 		ajax.php
*	Version: 		1.0
*	Author: 		Jerry Wood Jr. (Jerry)
*	Website: 		http://www.jjswebs.com
*	Email:			jay@jjswebs.com
*************************************************************************/

//define('DEBUG_AJAX', TRUE);

// This is so I can access the get_option() function and others as well.
require_once(dirname(__FILE__)."/../../../wp-load.php");

if(!$_SESSION){
	session_start();
}
// Filter the type of calls the script can handle.
$mode = empty($_GET['m']) ? 'empty' : $_GET['m'];
$p = empty($_GET['p']) ? 'empty' : $_GET['p'];
$d = empty($_GET['d']) ? 'empty' : $_GET['d'];
if(get_option('wpcwv2_sitewide') == 1 && $p != 'empty')
	$p = 'sitewide';
	
switch($mode){
	case 'checkUser':
		echo checkUser($p);
		break;
	case 'buildMessage':
		echo buildMessage();
		break;
	case 'giveData':
		echo giveData($p, $d);
		break;
	case 'buildDenial':
		echo buildMessage($d);
	default:
}

function checkUser($pageID){
	if(get_option('wpcwv2_use_denial')==1)
		if(isset($_COOKIE['wpcwv2_validated'][$pageID]) && !empty($_COOKIE['wpcwv2_validated'][$pageID]) && $_COOKIE['wpcwv2_validated'][$pageID] == '-1')
			if(get_option('wpcwv2_denial_option')==0)
				return 2;
			else
				return 3;
		elseif(isset($_SESSION['wpcwv2_validated'][$pageID]) && !empty($_SESSION['wpcwv2_validated'][$pageID]) && $_SESSION['wpcwv2_validated'][$pageID] == '-1')
			if(get_option('wpcwv2_denial_option')==0)
				return 2;
			else
				return 3;
		else
			return FALSE;	  
	elseif(isset($_COOKIE['wpcwv2_validated'][$pageID]) && !empty($_COOKIE['wpcwv2_validated'][$pageID]) && $_COOKIE['wpcwv2_validated'][$pageID] == '1')
		return TRUE;
	elseif(isset($_SESSION['wpcwv2_validated'][$pageID]) && !empty($_SESSION['wpcwv2_validated'][$pageID]) && $_SESSION['wpcwv2_validated'][$pageID] == '1')
		return TRUE;
		
	return FALSE;
}

function buildMessage($denial=FALSE)
{
	
	// Now we need to see what was used and use that accordingly
	// URL - 1, Page - 2 
	$ovr = get_option('wpcwv2_author_override'); // 0 - No & 1 - Yes
	if($ovr == TRUE){
		$enterType = get_option('wpcwv2_enter_use_which');
		$exitType = get_option('wpcwv2_exit_use_which');
		if($enterType == "1")
			$enter_url = get_option('wpcwv2_msg_enter_url');
		elseif($enterType == "2")
			$enter_url = get_page_uri(get_option('wpcwv2_enter_page_id'));
			
		if($exitType == "1")
			$exit_url = get_option('wpcwv2_msg_exit_url');
		elseif($exitType == "2")
			$exit_url = get_page_uri(get_option('wpcwv2_exit_page_id'));
	}elseif($ovr == FALSE){
		$enter_url = get_option('wpcwv2_msg_enter_url');
		$exit_url = get_option('wpcwv2_msg_exit_url');
	}
		
	// Read File
	$file = dirname(__FILE__).'/assets/message.html';
	$handle = fopen($file, "r"); 
    $output = fread($handle, filesize($file));
    fclose($handle); 
	
	// Get Contents
    $msg_title = get_option('wpcwv2_msg_title');
    $msg_title = empty($msg_title) ? 'Content Warning' : $msg_title;
    
    $msg_message = get_option('wpcwv2_msg_message');
    $msg_message = empty($msg_message) ? '<p>You are about to enter a website that may contain content of an adult nature. These pages are designed for ADULTS only and may include pictures and materials that some viewers may find offensive. If you are under the age of 18, if such material offends you or if it is illegal to view such material in your community please EXIT now.</p>' : $msg_message;
    
    $exit_text = get_option('wpcwv2_msg_exit_text');
    $exit_text = empty($exit_text) ? 'EXIT' : $exit_text;
    $exit_url = empty($exit_url) ? 'http://www.google.com' : $exit_url;
    
    $enter_text = get_option('wpcwv2_msg_enter_text');
    $enter_text = empty($enter_text) ? 'ENTER' : $enter_text;
	$enter_url = empty($enter_url) ? "#" : $enter_url;
	
	// Additional
	if(get_option('wpcwv2_use_denial') == 1){
		$exit_data = '<a href="#" onclick="denyUser()">'.$exit_text.'</a>';
	}else{
		$exit_data= '<a href="'.$exit_url.'">'.$exit_text.'</a> ';
	}
	
	if($denial==TRUE && get_option('wpcwv2_use_denial') == 1 && get_option('wpcwv2_denial_option')==1){
		$enter_data = "";
		$msg_message = get_option('wpcwv2_deny_message');
		$msg_title = get_option('wpcwv2_deny_title');
	}else{
		$enter_data = '<a href="'.$enter_url.'" onclick="wpdoor_remove(); return false;" class="wpdoor_enter">'.$enter_text.'</a>';
	}
    header('Content-type: text/html');
	
    // Format Output
    $output = str_replace('[msg_title]', $msg_title, $output);
    $output = str_replace('[msg_message]', $msg_message, $output);
    $output = str_replace('[exit_data]', $exit_data, $output);
    $output = str_replace('[enter_data]', $enter_data, $output);
    
    return $output;
}

function giveData($curPage, $d=FALSE){
	
	$cookie_expire = intval(get_option('wpcwv2_cookie_expire'));
	
	// SET COOKIE and SESSION
	if($cookie_expire < 86399 ) // If the time is less than 24 hours
		$expire = 0; // Expire End of Session
	else
		$expire = time() + $cookie_expire; // Expire in Specified Time
	/*
	* Small hack to allow a per-page / per-post cookie.  
	* This probably isn't the best idea since the end-user's computer could become
	* littered with cookies from larger WordPress sites, but it's a quick and easy
	* fix from my point of view.
	*/
	if(empty($curPage))
		$pag = "cookie_is_empty";
	else
		$pag = $curPage;
	
	if($d==TRUE && get_option('wpcwv2_use_denial') == 1)
		$cookieVal = '-1';
	else
		$cookieVal = '1';
	
		
	setcookie('wpcwv2_validated['.$pag.']', $cookieVal, $expire, SITECOOKIEPATH, COOKIE_DOMAIN);
	
	if("" == session_id())
		session_start();
		
	$_SESSION['wpcwv2_validated'][$pag] = $cookieVal;
}?>